<template>
  <crud-data-table-form-dialog
    v-model="dialog"
    :loading="isLoading"
    :dialog-title="$t('dialogTitle')"
    :dialog-subtitle="$t('dialogSubtitle')"
    :max-width="null"
    fullscreen
    @onClose="onCloseDialog"
    @onSave="onSave"
  >
    <expense-form
      v-model="form"
      :is-loading="isLoading"
      :installment-template="INSTALLMENT_TEMPLATE"
      @formRef="formRef = $event"
      @installmentsReset="installmentsResetCallback = $event"
    />
  </crud-data-table-form-dialog>
</template>

<script>
  import ExpenseForm from '../Form'

  const INSTALLMENT_TEMPLATE = {
    referenceMonth: '',
    amount: '',
    dueDate: '',
    paidOutAt: '',
  }
  const getFormInitialState = () => {
    return {
      purchaseDate: '',
      categoryId: '',
      paymentStatusId: '',
      paymentRecurrenceId: '',
      paymentMethodId: '',
      companyNickname: '',
      description: '',
      numberOfInstallments: '',
      installments: [{
        id: 0,
        ...INSTALLMENT_TEMPLATE,
      }],
    }
  }

  export default {
    name: 'CreateExpenseDialog',
    components: {
      ExpenseForm,
    },
    data () {
      return {
        dialog: false,
        isLoading: false,
        form: getFormInitialState(),
        formRef: null,
        INSTALLMENT_TEMPLATE,
        installmentsResetCallback: null,
      }
    },
    computed: {
      selectedPeriod () {
        return this.$store.getters['periods/getSelectedPeriod']
      },
    },
    methods: {
      closeDialogAndCleanForm () {
        this.dialog = false
        this.formRef.reset()
        this.installmentsResetCallback()
      },
      onCloseDialog () {
        this.closeDialogAndCleanForm()
      },
      onSave () {
        if (this.formRef.validate()) {
          this.isLoading = true
          this.$store.dispatch('expenses/createExpense', {
            form: {
              ...this.form,
              periodId: this.selectedPeriod.id,
            },
          })
            .then(() => {
              this.closeDialogAndCleanForm()
              this.$store.dispatch('toast/setOptions', {
                variant: 'success',
                text: this.$t('createSuccess'),
              })
            })
            .catch(() => {
              this.$store.dispatch('toast/setOptions', {
                variant: 'error',
                text: this.$t('createError'),
              })
            })
            .finally(() => {
              this.isLoading = false
            })
        }
      },
    },
    i18n: {
      messages: {
        'pt-BR': {
          dialogTitle: 'Cadastro de despesa',
          dialogSubtitle: 'Os campos marcados com o asterísco (*) são obrigatórios.',
          createSuccess: 'Despesa adicionada com sucesso!',
          createError: 'Ops... Algo deu errado ao tentar adicionar a despesa. Por favor, tente novamente.',
        },
        'en-US': {
          dialogTitle: 'Expense registration',
          dialogSubtitle: 'Fields marked with an asterisk (*) are required.',
          createSuccess: 'Expense successfully added!',
          createError: 'Oops... Something went wrong while trying to add the expense. Please try again.',
        },
      },
    },
  }
</script>
